Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management.openmbean
Class OpenMBeanAttributeInfoSupport

    java.lang.Object
      |
      +--javax.management.MBeanFeatureInfo
            |
            +--javax.management.MBeanAttributeInfo
                  |
                  +--javax.management.openmbean.OpenMBeanAttributeInfoSupport

All Implemented Interfaces:
  java.lang.Cloneable, OpenMBeanAttributeInfo, OpenMBeanParameterInfo, java.io.Serializable

public class OpenMBeanAttributeInfoSupport
extends MBeanAttributeInfo
implements OpenMBeanAttributeInfo, java.io.Serializable

Describes an attribute of an open MBean.

Author:
  Young Yang
See Also:
  Serialized Form

Fields inherited from class javax.management.MBeanFeatureInfo
`description, name`

Constructor Summary
`OpenMBeanAttributeInfoSupport(java.lang.String name, java.lang.String description, OpenType openType, boolean isReadable, boolean isWritable, boolean isIs)` Constructs an `OpenMBeanAttributeInfoSupport` instance, which describes the attribute of an open MBean with the specified name, openType and description, and the specified read/write access properties.
`OpenMBeanAttributeInfoSupport(java.lang.String name, java.lang.String description, OpenType openType, boolean isReadable, boolean isWritable, boolean isIs, java.lang.Object defaultValue)` Constructs an `OpenMBeanAttributeInfoSupport` instance, which describes the attribute of an open MBean with the specified name, openType, description and defaultValue, and the specified read/write access properties.
`OpenMBeanAttributeInfoSupport(java.lang.String name, java.lang.String description, OpenType openType, boolean isReadable, boolean isWritable, boolean isIs, java.lang.Object defaultValue, java.lang.Comparable minValue, java.lang.Comparable maxValue)` Constructs an `OpenMBeanAttributeInfoSupport` instance, which describes the attribute used in one or more operations or constructors of a class of open MBeans, with the specified name, openType, description, defaultValue, minValue and maxValue.
`OpenMBeanAttributeInfoSupport(java.lang.String name, java.lang.String description, OpenType openType, boolean isReadable, boolean isWritable, boolean isIs, java.lang.Object defaultValue, java.lang.Object[] legalValues)` Constructs an `OpenMBeanAttributeInfoSupport` instance, which describes the attribute of an open MBean with the specified name, openType, description, defaultValue and legalValues, and the specified read/write access properties.

Method Summary
`boolean` | `equals(java.lang.Object obj)` Compares the specified obj parameter with this `OpenMBeanAttributeInfoSupport` instance for equality.
`java.lang.Object` | `getDefaultValue()` Returns the default value for the attribute described by this `OpenMBeanAttributeInfoSupport` instance, if specified, or `null` otherwise.
`java.util.Set` | `getLegalValues()` Returns an unmodifiable Set of legal values for the attribute described by this `OpenMBeanAttributeInfoSupport` instance, if specified, or `null` otherwise.
`java.lang.Comparable` | `getMaxValue()` Returns the maximal value for the attribute described by this `OpenMBeanAttributeInfoSupport` instance, if specified, or `null` otherwise.
`java.lang.Comparable` | `getMinValue()` Returns the minimal value for the attribute described by this `OpenMBeanAttributeInfoSupport` instance, if specified, or `null` otherwise.
`OpenType` | `getOpenType()` Returns the open type for the values of the attribute described by this `OpenMBeanAttributeInfoSupport` instance.
`boolean` | `hasDefaultValue()` Returns `true` if this `OpenMBeanAttributeInfoSupport` instance specifies a non-null default value for the described attribute, `false` otherwise.
`int` | `hashCode()` Returns the hash code value for this `OpenMBeanAttributeInfoSupport` instance.
`boolean` | `hasLegalValues()` Returns `true` if this `OpenMBeanAttributeInfoSupport` instance specifies a non-null set of legal values for the described attribute, `false` otherwise.
`boolean` | `hasMaxValue()` Returns `true` if this `OpenMBeanAttributeInfoSupport` instance specifies a non-null maximal value for the described attribute, `false` otherwise.
`boolean` | `hasMinValue()` Returns `true` if this `OpenMBeanAttributeInfoSupport` instance specifies a non-null minimal value for the described attribute, `false` otherwise.
`boolean` | `isValue(java.lang.Object obj)` Tests whether obj is a valid value for the attribute described by this `OpenMBeanAttributeInfoSupport` instance.
`java.lang.String` | `toString()` Returns a string representation of this `OpenMBeanAttributeInfoSupport` instance.

Methods inherited from class javax.management.MBeanAttributeInfo
`clone, getType, isIs, isReadable, isWritable`

Methods inherited from class javax.management.MBeanFeatureInfo
`getDescription, getName`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface javax.management.openmbean.OpenMBeanAttributeInfo
`isIs, isReadable, isWritable`

Methods inherited from interface javax.management.openmbean.OpenMBeanParameterInfo
`getDescription, getName`

Constructor Detail

### OpenMBeanAttributeInfoSupport

    public OpenMBeanAttributeInfoSupport(java.lang.String name,
                                         java.lang.String description,
                                         OpenType openType,
                                         boolean isReadable,
                                         boolean isWritable,
                                         boolean isIs)

  Constructs an `OpenMBeanAttributeInfoSupport` instance, which describes the attribute of an open MBean with the specified name, openType and description, and the specified read/write access properties.
  Parameters:
    `name` - cannot be a null or empty string.
    `description` - cannot be a null or empty string.
    `openType` - cannot be null.
    `isReadable` - `true` if the attribute has a getter exposed for management.
    `isWritable` - `true` if the attribute has a setter exposed for management.
    `isIs` - `true` if the attribute's getter is of the form `isXXX`.
  Throws:
    `java.lang.IllegalArgumentException` - if name or description are null or empty string, or openType is null.

### OpenMBeanAttributeInfoSupport

    public OpenMBeanAttributeInfoSupport(java.lang.String name,
                                         java.lang.String description,
                                         OpenType openType,
                                         boolean isReadable,
                                         boolean isWritable,
                                         boolean isIs,
                                         java.lang.Object defaultValue)
                                  throws OpenDataException

  Constructs an `OpenMBeanAttributeInfoSupport` instance, which describes the attribute of an open MBean with the specified name, openType, description and defaultValue, and the specified read/write access properties.
  Parameters:
    `name` - cannot be a null or empty string.
    `description` - cannot be a null or empty string.
    `openType` - cannot be null.
    `isReadable` - `true` if the attribute has a getter exposed for management.
    `isWritable` - `true` if the attribute has a setter exposed for management.
    `isIs` - `true` if the attribute's getter is of the form `isXXX`.
    `defaultValue` - must be a valid value for the openType specified for this attribute; default value not supported for `ArrayType` and `TabularType`; can be null, in which case it means that no default value is set.
  Throws:
    `java.lang.IllegalArgumentException` - if name or description are null or empty string, or openType is null.
    `OpenDataException` - if defaultValue is not a valid value for the specified openType, or defaultValue is non null and openType is an `ArrayType` or a `TabularType`.

### OpenMBeanAttributeInfoSupport

    public OpenMBeanAttributeInfoSupport(java.lang.String name,
                                         java.lang.String description,
                                         OpenType openType,
                                         boolean isReadable,
                                         boolean isWritable,
                                         boolean isIs,
                                         java.lang.Object defaultValue,
                                         java.lang.Object[] legalValues)
                                  throws OpenDataException

  Constructs an `OpenMBeanAttributeInfoSupport` instance, which describes the attribute of an open MBean with the specified name, openType, description, defaultValue and legalValues, and the specified read/write access properties. The contents of legalValues are internally dumped into an unmodifiable `Set`, so subsequent modifications of the array referenced by legalValues have no impact on this `OpenMBeanAttributeInfoSupport` instance.
  Parameters:
    `name` - cannot be a null or empty string.
    `description` - cannot be a null or empty string.
    `openType` - cannot be null.
    `isReadable` - `true` if the attribute has a getter exposed for management.
    `isWritable` - `true` if the attribute has a setter exposed for management.
    `isIs` - `true` if the attribute's getter is of the form `isXXX`.
    `defaultValue` - must be a valid value for the openType specified for this attribute; default value not supported for `ArrayType` and `TabularType`; can be null, in which case it means that no default value is set.
    `legalValues` - each contained value must be valid for the openType specified for this attribute; legal values not supported for `ArrayType` and `TabularType`; can be null or empty.
  Throws:
    `java.lang.IllegalArgumentException` - if name or description are null or empty string, or openType is null.
    `OpenDataException` - if defaultValue is not a valid value for the specified openType, or one value in legalValues is not valid for the specified openType, or defaultValue is non null and openType is an `ArrayType` or a `TabularType`, or legalValues is non null and non empty and openType is an `ArrayType` or a `TabularType`, or legalValues is non null and non empty and defaultValue is not contained in legalValues.

### OpenMBeanAttributeInfoSupport

    public OpenMBeanAttributeInfoSupport(java.lang.String name,
                                         java.lang.String description,
                                         OpenType openType,
                                         boolean isReadable,
                                         boolean isWritable,
                                         boolean isIs,
                                         java.lang.Object defaultValue,
                                         java.lang.Comparable minValue,
                                         java.lang.Comparable maxValue)
                                  throws OpenDataException

  Constructs an `OpenMBeanAttributeInfoSupport` instance, which describes the attribute used in one or more operations or constructors of a class of open MBeans, with the specified name, openType, description, defaultValue, minValue and maxValue. It is possible to specify minimal and maximal values only for an open type whose values are `Comparable`.
  Parameters:
    `name` - cannot be a null or empty string.
    `description` - cannot be a null or empty string.
    `openType` - cannot be null.
    `isReadable` - `true` if the attribute has a getter exposed for management.
    `isWritable` - `true` if the attribute has a setter exposed for management.
    `isIs` - `true` if the attribute's getter is of the form `isXXX`.
    `defaultValue` - must be a valid value for the openType specified for this attribute; default value not supported for `ArrayType` and `TabularType`; can be null, in which case it means that no default value is set.
    `minValue` - must be valid for the openType specified for this attribute; can be null, in which case it means that no minimal value is set.
    `maxValue` - must be valid for the openType specified for this attribute; can be null, in which case it means that no maximal value is set.
  Throws:
    `java.lang.IllegalArgumentException` - if name or description are null or empty string, or openType is null.
    `OpenDataException` - if defaultValue, minValue or maxValue is not a valid value for the specified openType, or defaultValue is non null and openType is an `ArrayType` or a `TabularType`, or both minValue and maxValue are non-null and `minValue.compareTo(maxValue) > 0` is `true`, or both defaultValue and minValue are non-null and `minValue.compareTo(defaultValue) > 0` is `true`, or both defaultValue and maxValue are non-null and `defaultValue.compareTo(maxValue) > 0` is `true`.

Method Detail

### getOpenType

    public OpenType getOpenType()

  Returns the open type for the values of the attribute described by this `OpenMBeanAttributeInfoSupport` instance.
  Specified by:
    `getOpenType` in interface `OpenMBeanParameterInfo`
  Following copied from interface: `javax.management.openmbean.OpenMBeanParameterInfo`
  Returns:
    the open type.

### getDefaultValue

    public java.lang.Object getDefaultValue()

  Returns the default value for the attribute described by this `OpenMBeanAttributeInfoSupport` instance, if specified, or `null` otherwise.
  Specified by:
    `getDefaultValue` in interface `OpenMBeanParameterInfo`
  Following copied from interface: `javax.management.openmbean.OpenMBeanParameterInfo`
  Returns:
    the default value.

### getLegalValues

    public java.util.Set getLegalValues()

  Returns an unmodifiable Set of legal values for the attribute described by this `OpenMBeanAttributeInfoSupport` instance, if specified, or `null` otherwise.
  Specified by:
    `getLegalValues` in interface `OpenMBeanParameterInfo`
  Following copied from interface: `javax.management.openmbean.OpenMBeanParameterInfo`
  Returns:
    the set of legal values.

### getMinValue

    public java.lang.Comparable getMinValue()

  Returns the minimal value for the attribute described by this `OpenMBeanAttributeInfoSupport` instance, if specified, or `null` otherwise.
  Specified by:
    `getMinValue` in interface `OpenMBeanParameterInfo`
  Following copied from interface: `javax.management.openmbean.OpenMBeanParameterInfo`
  Returns:
    the minimum value.

### getMaxValue

    public java.lang.Comparable getMaxValue()

  Returns the maximal value for the attribute described by this `OpenMBeanAttributeInfoSupport` instance, if specified, or `null` otherwise.
  Specified by:
    `getMaxValue` in interface `OpenMBeanParameterInfo`
  Following copied from interface: `javax.management.openmbean.OpenMBeanParameterInfo`
  Returns:
    the maximum value.

### hasDefaultValue

    public boolean hasDefaultValue()

  Returns `true` if this `OpenMBeanAttributeInfoSupport` instance specifies a non-null default value for the described attribute, `false` otherwise.
  Specified by:
    `hasDefaultValue` in interface `OpenMBeanParameterInfo`
  Following copied from interface: `javax.management.openmbean.OpenMBeanParameterInfo`
  Returns:
    true if there is a default value.

### hasLegalValues

    public boolean hasLegalValues()

  Returns `true` if this `OpenMBeanAttributeInfoSupport` instance specifies a non-null set of legal values for the described attribute, `false` otherwise.
  Specified by:
    `hasLegalValues` in interface `OpenMBeanParameterInfo`
  Following copied from interface: `javax.management.openmbean.OpenMBeanParameterInfo`
  Returns:
    true if there is a set of legal values.

### hasMinValue

    public boolean hasMinValue()

  Returns `true` if this `OpenMBeanAttributeInfoSupport` instance specifies a non-null minimal value for the described attribute, `false` otherwise.
  Specified by:
    `hasMinValue` in interface `OpenMBeanParameterInfo`
  Following copied from interface: `javax.management.openmbean.OpenMBeanParameterInfo`
  Returns:
    true if there is a minimum value.

### hasMaxValue

    public boolean hasMaxValue()

  Returns `true` if this `OpenMBeanAttributeInfoSupport` instance specifies a non-null maximal value for the described attribute, `false` otherwise.
  Specified by:
    `hasMaxValue` in interface `OpenMBeanParameterInfo`
  Following copied from interface: `javax.management.openmbean.OpenMBeanParameterInfo`
  Returns:
    true if there is a maximum value.

### isValue

    public boolean isValue(java.lang.Object obj)

  Tests whether obj is a valid value for the attribute described by this `OpenMBeanAttributeInfoSupport` instance.
  Specified by:
    `isValue` in interface `OpenMBeanParameterInfo`
  Parameters:
    `obj` - the object to be tested.
  Returns:
    `true` if obj is a valid value for for the parameter described by this `OpenMBeanAttributeInfoSupport` instance, `false` otherwise.

### equals

    public boolean equals(java.lang.Object obj)

  Compares the specified obj parameter with this `OpenMBeanAttributeInfoSupport` instance for equality.

  Returns `true` if and only if all of the following statements are true:

  - obj is non null,
  - obj also implements the `OpenMBeanAttributeInfo` interface,
  - their names are equal
  - their open types are equal
  - their access properties (isReadable, isWritable and isIs) are equal
  - their default, min, max and legal values are equal.
  This ensures that this `equals` method works properly for obj parameters which are different implementations of the `OpenMBeanAttributeInfo` interface.
  Specified by:
    `equals` in interface `OpenMBeanAttributeInfo`
  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `obj` - the object to be compared for equality with this `OpenMBeanAttributeInfoSupport` instance;
  Returns:
    `true` if the specified object is equal to this `OpenMBeanAttributeInfoSupport` instance.

### hashCode

    public int hashCode()

  Returns the hash code value for this `OpenMBeanAttributeInfoSupport` instance.

  The hash code of an `OpenMBeanAttributeInfoSupport` instance is the sum of the hash codes of all elements of information used in `equals` comparisons (ie: its name, its open type, and its default, min, max and legal values).

  This ensures that `t1.equals(t2)` implies that `t1.hashCode()==t2.hashCode()` for any two `OpenMBeanAttributeInfoSupport` instances `t1` and `t2`, as required by the general contract of the method `Object.hashCode` .

  However, note that another instance of a class implementing the `OpenMBeanAttributeInfo` interface may be equal to this `OpenMBeanAttributeInfoSupport` instance as defined by `equals(java.lang.Object)`, but may have a different hash code if it is calculated differently.

  As `OpenMBeanAttributeInfoSupport` instances are immutable, the hash code for this instance is calculated once, on the first call to `hashCode`, and then the same value is returned for subsequent calls.

  Specified by:
    `hashCode` in interface `OpenMBeanAttributeInfo`
  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    the hash code value for this `OpenMBeanAttributeInfoSupport` instance

### toString

    public java.lang.String toString()

  Returns a string representation of this `OpenMBeanAttributeInfoSupport` instance.

  The string representation consists of the name of this class (ie `javax.management.openmbean.OpenMBeanAttributeInfoSupport`), the string representation of the name and open type of the described parameter, and the string representation of its default, min, max and legal values.

  As `OpenMBeanAttributeInfoSupport` instances are immutable, the string representation for this instance is calculated once, on the first call to `toString`, and then the same value is returned for subsequent calls.

  Specified by:
    `toString` in interface `OpenMBeanAttributeInfo`
  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    a string representation of this `OpenMBeanAttributeInfoSupport` instance

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD